    001/*
    002    Licensed to the Apache Software Foundation (ASF) under one
    003    or more contributor license agreements.  See the NOTICE file
    004    distributed with this work for additional information
    005    regarding copyright ownership.  The ASF licenses this file
    006    to you under the Apache License, Version 2.0 (the
    007    "License"); you may not use this file except in compliance
    008    with the License.  You may obtain a copy of the License at
    009
    010       http://www.apache.org/licenses/LICENSE-2.0
    011
    012    Unless required by applicable law or agreed to in writing,
    013    software distributed under the License is distributed on an
    014    "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015    KIND, either express or implied.  See the License for the
    016    specific language governing permissions and limitations
    017    under the License.
    018 */
    019package org.apache.wiki.api.plugin;
    020
    021import org.apache.wiki.api.core.Engine;
    022import org.apache.wiki.api.exceptions.PluginException;
    023
    024/**
    025 *  If a plugin defines this interface, it is called exactly once prior to the actual execute() routine.  If the plugin has its
    026 *  own declaration in jspwiki_modules.xml, then it is called during startup - otherwise it is called the first time the plugin is
    027 *  encountered.
    028 *  <p>
    029 *  This method did not actually work until 2.5.30.  The method signature has been changed in 2.6 to reflect the new operation.
    030 */
    031public interface InitializablePlugin {
    032
    033    /**
    034     *  Called whenever the plugin is being instantiated for the first time.
    035     *
    036     *  @param engine The Engine.
    037     *  @throws PluginException If something goes wrong.
    038     */
    039    void initialize( Engine engine ) throws PluginException;
    040
    041}